Package org.springframework.jmx.export.assembler

# Class InterfaceBasedMBeanInfoAssembler

java.lang.Object
org.springframework.jmx.export.assembler.AbstractMBeanInfoAssembler
org.springframework.jmx.export.assembler.AbstractReflectiveMBeanInfoAssembler
org.springframework.jmx.export.assembler.AbstractConfigurableMBeanInfoAssembler
org.springframework.jmx.export.assembler.InterfaceBasedMBeanInfoAssembler

All Implemented Interfaces:
  `org.springframework.beans.factory.Aware`, `org.springframework.beans.factory.BeanClassLoaderAware`, `org.springframework.beans.factory.InitializingBean`, `MBeanInfoAssembler`

public class InterfaceBasedMBeanInfoAssembler extends AbstractConfigurableMBeanInfoAssembler implements org.springframework.beans.factory.BeanClassLoaderAware, org.springframework.beans.factory.InitializingBean
Subclass of `AbstractReflectiveMBeanInfoAssembler` that allows for the management interface of a bean to be defined using arbitrary interfaces. Any methods or properties that are defined in those interfaces are exposed as MBean operations and attributes.

By default, this class votes on the inclusion of each operation or attribute based on the interfaces implemented by the bean class. However, you can supply an array of interfaces via the `managedInterfaces` property that will be used instead. If you have multiple beans and you wish each bean to use a different set of interfaces, then you can map bean keys (that is the name used to pass the bean to the `MBeanExporter`) to a list of interface names using the `interfaceMappings` property.

If you specify values for both `interfaceMappings` and `managedInterfaces`, Spring will attempt to find interfaces in the mappings first. If no interfaces for the bean are found, it will use the interfaces defined by `managedInterfaces`.

Since:
  1.2
Author:
  Rob Harrop, Juergen Hoeller
See Also:
  - `setManagedInterfaces(java.lang.Class<?>...)`
  - `setInterfaceMappings(java.util.Properties)`
  - `MethodNameBasedMBeanInfoAssembler`
  - `SimpleReflectiveMBeanInfoAssembler`
  - `MBeanExporter`

## Field Summary

### Fields inherited from class org.springframework.jmx.export.assembler.AbstractReflectiveMBeanInfoAssembler

`ATTRIBUTE_OPERATION_VISIBILITY, FIELD_CLASS, FIELD_CURRENCY_TIME_LIMIT, FIELD_DEFAULT, FIELD_DISPLAY_NAME, FIELD_GET_METHOD, FIELD_LOG, FIELD_LOG_FILE, FIELD_METRIC_CATEGORY, FIELD_METRIC_TYPE, FIELD_PERSIST_LOCATION, FIELD_PERSIST_NAME, FIELD_PERSIST_PERIOD, FIELD_PERSIST_POLICY, FIELD_ROLE, FIELD_SET_METHOD, FIELD_UNITS, FIELD_VISIBILITY, ROLE_GETTER, ROLE_OPERATION, ROLE_SETTER`

## Constructor Summary

Constructors
Constructor
Description
`InterfaceBasedMBeanInfoAssembler()`

## Method Summary

Modifier and Type
Method
Description
`void`
`afterPropertiesSet()`
`protected boolean`
`includeOperation(Method method, String beanKey)`
Check to see if the `Method` is declared in one of the configured interfaces and that it is public.
`protected boolean`
`includeReadAttribute(Method method, String beanKey)`
Check to see if the `Method` is declared in one of the configured interfaces and that it is public.
`protected boolean`
`includeWriteAttribute(Method method, String beanKey)`
Check to see if the `Method` is declared in one of the configured interfaces and that it is public.
`void`
`setBeanClassLoader(ClassLoader beanClassLoader)`
`void`
`setInterfaceMappings(Properties mappings)`
Set the mappings of bean keys to a comma-separated list of interface names.
`void`
`setManagedInterfaces(Class<?>... managedInterfaces)`
Set the array of interfaces to use for creating the management info.

### Methods inherited from class org.springframework.jmx.export.assembler.AbstractConfigurableMBeanInfoAssembler

`getNotificationInfo, setNotificationInfoMappings, setNotificationInfos`

### Methods inherited from class org.springframework.jmx.export.assembler.AbstractReflectiveMBeanInfoAssembler

`applyCurrencyTimeLimit, applyDefaultCurrencyTimeLimit, createModelMBeanOperationInfo, getAttributeDescription, getAttributeInfo, getClassForDescriptor, getDefaultCurrencyTimeLimit, getOperationDescription, getOperationInfo, getOperationParameters, getParameterNameDiscoverer, isExposeClassDescriptor, isUseStrictCasing, populateAttributeDescriptor, populateMBeanDescriptor, populateOperationDescriptor, setDefaultCurrencyTimeLimit, setExposeClassDescriptor, setParameterNameDiscoverer, setUseStrictCasing`

### Methods inherited from class org.springframework.jmx.export.assembler.AbstractMBeanInfoAssembler

`checkManagedBean, getClassName, getClassToExpose, getClassToExpose, getConstructorInfo, getDescription, getMBeanInfo, getTargetClass`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### InterfaceBasedMBeanInfoAssembler

public InterfaceBasedMBeanInfoAssembler()

## Method Details

### setManagedInterfaces

public void setManagedInterfaces(@Nullable Class<?>... managedInterfaces)
Set the array of interfaces to use for creating the management info. These interfaces will be used for a bean if no entry corresponding to that bean is found in the `interfaceMappings` property.

Parameters:
  `managedInterfaces` - an array of classes indicating the interfaces to use. Each entry MUST be an interface.
See Also:
  - `setInterfaceMappings(java.util.Properties)`

### setInterfaceMappings

public void setInterfaceMappings(@Nullable Properties mappings)
Set the mappings of bean keys to a comma-separated list of interface names.

The property key should match the bean key and the property value should match the list of interface names. When searching for interfaces for a bean, Spring will check these mappings first.

Parameters:
  `mappings` - the mappings of bean keys to interface names

### setBeanClassLoader

public void setBeanClassLoader(@Nullable ClassLoader beanClassLoader)

Specified by:
  `setBeanClassLoader` in interface `org.springframework.beans.factory.BeanClassLoaderAware`

### afterPropertiesSet

public void afterPropertiesSet()

Specified by:
  `afterPropertiesSet` in interface `org.springframework.beans.factory.InitializingBean`

### includeReadAttribute

protected boolean includeReadAttribute(Method method, String beanKey)
Check to see if the `Method` is declared in one of the configured interfaces and that it is public.

Specified by:
  `includeReadAttribute` in class `AbstractReflectiveMBeanInfoAssembler`
Parameters:
  `method` - the accessor `Method`.
  `beanKey` - the key associated with the MBean in the `beans` `Map`.
Returns:
  `true` if the `Method` is declared in one of the configured interfaces, otherwise `false`.

### includeWriteAttribute

protected boolean includeWriteAttribute(Method method, String beanKey)
Check to see if the `Method` is declared in one of the configured interfaces and that it is public.

Specified by:
  `includeWriteAttribute` in class `AbstractReflectiveMBeanInfoAssembler`
Parameters:
  `method` - the mutator `Method`.
  `beanKey` - the key associated with the MBean in the `beans` `Map`.
Returns:
  `true` if the `Method` is declared in one of the configured interfaces, otherwise `false`.

### includeOperation

protected boolean includeOperation(Method method, String beanKey)
Check to see if the `Method` is declared in one of the configured interfaces and that it is public.

Specified by:
  `includeOperation` in class `AbstractReflectiveMBeanInfoAssembler`
Parameters:
  `method` - the operation `Method`.
  `beanKey` - the key associated with the MBean in the `beans` `Map`.
Returns:
  `true` if the `Method` is declared in one of the configured interfaces, otherwise `false`.